include: .gitlab-ci/common.yml


stages:
  - release


set-version:
  extends: .git-setup
  image: python:3.11.2
  variables:
    CLONE_CHECKOUT_BRANCH: $CI_COMMIT_BRANCH
  script:
    # install requirements
    - pip install poetry
    # update version
    - poetry version $CURRENT_TAG
    - poetry version major 
    - TAG="$(poetry version --short)"
    # update openapi specs version
    - python ./scripts/set_specs_version.py $TAG
    # push to repo
    - git add -u && git add .
    - git diff --quiet && git diff --staged --quiet || git commit -m ".Set $TAG project version"
    - git push --all


generate-changelog:
  extends: .git-setup
  needs: [set-version]
  script:
    - TAG="$(semver bump major $CURRENT_TAG)"
    - git tag $TAG
    - git-chglog -o $CHANGELOG_MD
    - git tag -d $TAG
    - git add $CHANGELOG_MD
    - git diff --quiet && git diff --staged --quiet || git commit -m ".Add changelog for $TAG version"
    - git push origin $CI_DEFAULT_BRANCH


release-branch-and-tag:
  extends: .git-setup
  needs: [generate-changelog]
  script:
    - TAG="$(semver bump major $CURRENT_TAG)"
    - BRANCH="${RELEASE_BRANCH_PREFIX}$TAG"
    - git checkout -b $BRANCH
    - git tag $TAG
    - git push origin $BRANCH
    - git push origin --tags

